"use strict";
function Case(value, fn) {
    return {
        fn,
        matches: (x) => ((typeof value === "function" && x instanceof value)
            || (typeof value === typeof x && value === x)),
    };
}
exports.Case = Case;
function DefaultCase(val) {
    if (!val) {
        return {
            fn: (() => { })
        };
    }
    if (typeof val === 'function') {
        return {
            fn: val
        };
    }
    return {
        fn: (() => val)
    };
}
exports.DefaultCase = DefaultCase;
function match(input, defaultCase, ...cases) {
    for (const k of cases) {
        if (k.matches(input)) {
            return k.fn(input);
        }
    }
    return defaultCase.fn();
}
exports.match = match;
